/* Faan Tone Liu
 * Demo program from 1671
 * Shows a loop that reads integers out of a file, throws away
 * non-integer input, and quits at the end of the file.
 * Counts the number of integers found, outputs this number
 */
#include <iostream>
#include <fstream>
#include <cctype>
using namespace std;

int main()
{
    ifstream infile;  // input file
    int num;          // number read out of file
    int count(0);     // number of integers successfully read from file
    char flushchar;   // character to throw away

    // open the input file
    infile.open("datafile.dat");

    // if the file opened okay, then read its contents
    if (infile) {
        // read number out of the file until we hit the end of file
        do {
           // get a number out of the file
           infile >> num;
           // if input wokred then process the number (count it)
           if (infile) {
               count++;
           }
           // if the input failed, but we're not at the end of file,
           // then reset file and skip until we hit a space
           if (!infile && !infile.eof()) {
               infile.clear(0);
               do {
                   infile.get(flushchar);
               } while (!infile.eof() && !isspace(flushchar));
           } 
        } while (!infile.eof());
        // output the number of valid numbers we read
        cout << "There are " << count << " valid items in the file\n";
    } else {
        // output a message if the file open failed
        cout << "Unable to open input file datafile.dat\n";
    }
    infile.close();
    return 0;
}


